## dwarves-dfsg 1.3

=== CMakeLists.txt ===
project(pahole C)

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )

# Try to parse this later, Helio just showed me a KDE4 example to support
# x86-64 builds.
# the following are directories where stuff will be installed to
set(__LIB "" CACHE STRING "Define suffix of directory name (32/64)" )

macro(_set_fancy _var _value _comment)
	if (NOT DEFINED ${_var})
		set(${_var} ${_value})
	else (NOT DEFINED ${_var})
		set(${_var} "${${_var}}" CACHE PATH "${_comment}")
	endif (NOT DEFINED ${_var})
endmacro(_set_fancy)

# where to look first for cmake modules,
# before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

if (NOT CMAKE_BUILD_TYPE)
	set (CMAKE_BUILD_TYPE Debug CACHE STRING
	     "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
	     FORCE)
endif (NOT CMAKE_BUILD_TYPE)

add_definitions(-D_GNU_SOURCE)
find_package(DWARF REQUIRED)

_set_fancy(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}${CMAKE_INSTALL_PREFIX}/${__LIB}" "libdir")

set(dwarves_LIB_SRCS dwarves.c)
add_library(dwarves SHARED ${dwarves_LIB_SRCS})
set_target_properties(dwarves PROPERTIES VERSION 1.0.0 SOVERSION 1)
target_link_libraries(dwarves ${DWARF_LIBRARIES})

set(dwarves_emit_LIB_SRCS dwarves_emit.c)
add_library(dwarves_emit SHARED ${dwarves_emit_LIB_SRCS})
set_target_properties(dwarves_emit PROPERTIES VERSION 1.0.0 SOVERSION 1)
target_link_libraries(dwarves_emit ${DWARF_LIBRARIES} dwarves)

set(dwarves_reorganize_LIB_SRCS dwarves_reorganize.c)
add_library(dwarves_reorganize SHARED ${dwarves_reorganize_LIB_SRCS})
set_target_properties(dwarves_reorganize PROPERTIES VERSION 1.0.0 SOVERSION 1)
target_link_libraries(dwarves_reorganize ${DWARF_LIBRARIES} dwarves)

set(codiff_SRCS codiff.c)
add_executable(codiff ${codiff_SRCS})
target_link_libraries(codiff dwarves)

set(ctracer_SRCS ctracer.c dutil.c)
add_executable(ctracer ${ctracer_SRCS})
target_link_libraries(ctracer dwarves dwarves_emit dwarves_reorganize)

set(dtagnames_SRCS dtagnames.c)
add_executable(dtagnames ${dtagnames_SRCS})
target_link_libraries(dtagnames dwarves)

set(pahole_SRCS pahole.c)
add_executable(pahole ${pahole_SRCS})
target_link_libraries(pahole dwarves dwarves_reorganize)

set(pdwtags_SRCS pdwtags.c)
add_executable(pdwtags ${pdwtags_SRCS})
target_link_libraries(pdwtags dwarves)

set(pglobal_SRCS pglobal.c)
add_executable(pglobal ${pglobal_SRCS})
target_link_libraries(pglobal dwarves)

set(pfunct_SRCS pfunct.c )
add_executable(pfunct ${pfunct_SRCS})
target_link_libraries(pfunct dwarves)

set(prefcnt_SRCS prefcnt.c)
add_executable(prefcnt ${prefcnt_SRCS})
target_link_libraries(prefcnt dwarves)

set(syscse_SRCS syscse.c)
add_executable(syscse ${syscse_SRCS})
target_link_libraries(syscse dwarves)

install(TARGETS codiff ctracer dtagnames pahole pdwtags
		pfunct pglobal prefcnt syscse RUNTIME DESTINATION
		${CMAKE_INSTALL_PREFIX}/bin)
install(TARGETS dwarves LIBRARY DESTINATION ${LIB_INSTALL_DIR})
install(TARGETS dwarves dwarves_emit dwarves_reorganize LIBRARY DESTINATION ${LIB_INSTALL_DIR})
install(FILES dwarves.h dwarves_emit.h dwarves_reorganize.h DESTINATION ${CMAKE_INSTALL_PREFIX}/include)
install(PROGRAMS ostra/ostra-cg DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
install(FILES ostra/python/ostra.py DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime/python)
install(FILES lib/Makefile lib/ctracer_relay.c lib/ctracer_relay.h lib/linux.blacklist.cu
	DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime)

## dwarves-dfsg 1.9

=== debian/changelog ===
dwarves-dfsg (1.9-1) unstable; urgency=low

  * Acknowledge 1.3-1.1 NMU (thanks to Michael Banck) and resynch with
    Ubuntu release (thanks Bhavani Shankar).
  * New upstream release:
    - patch from 1.3-1.1ubuntu1 no longer needed.
    - new manpage for pahole.
    - new program scncopy to copy ELF sections.
    - fixes crash when encountering a pointer in a struct. Closes: #513573.
    - recognizes C++ classes. Closes: #621530.
    - no longer FTBFS with gcc 4.6. Closes: #625158.
  * Remove libebl detection and use. Closes: #534529.
  * debian/control:
    - bump debhelper level to 7.
    - add Vcs-Git: and Vcs-Browser:
    - bump Standards-Version: to 3.9.2.
    - add zlib1g-dev build dependency.
  * debian/copyright: add missing copyright holders.
  * debian/rules:
    - allow to be compiled twice in a row.
    - ensure package building aborts if a program is not installed.
    - use dh_prep instead of dh_clean -k.
  * debian/dwarves.install:
    - include syscse. Closes: #517180.
    - add ctracer. See README.ctracer for information on how to use it.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Fix many lintian warnings.

 -- Thomas Girard <thomas.g.girard@free.fr>  Mon, 02 May 2011 19:34:31 +0200

dwarves-dfsg (1.3-1.1ubuntu1) maverick; urgency=low

  * dwarwes-dfsg-1.3/src/dwarves.c:
    + Add missing headers to fix undefined reference to `S_IS*' linker 
      error with gcc 4.5 LP: #602367

 -- Bhavani Shankar <bhavi@ubuntu.com>  Tue, 06 Jul 2010 22:20:38 +0530

dwarves-dfsg (1.3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Applied patch by Peter Green (Closes: #534084)
    + cmake/modules/FindDWARF.cmake: Removed libebl support.
    + debian/control (Build-Depends): Removed libebl-dev. 

 -- Michael Banck <mbanck@debian.org>  Sun, 29 Nov 2009 12:45:58 +0100

dwarves-dfsg (1.3-1) unstable; urgency=low

  * Initial release, based on Domenico Andreoli <cavok@debian.org> work.
    Closes: #436522.

 -- Thomas Girard <thomas.g.girard@free.fr>  Mon, 24 Dec 2007 10:14:17 +0100

=== debian/control ===
Source: dwarves-dfsg
Priority: extra
Maintainer: Thomas Girard <thomas.g.girard@free.fr>
Uploaders: Domenico Andreoli <cavok@debian.org>
Build-Depends: debhelper (>= 7), libelf-dev, libdw-dev (>= 0.141), cmake (>= 2.4.8), zlib1g-dev
Standards-Version: 3.9.2
Section: utils
Vcs-Git: git://git.debian.org/collab-maint/pkg-dwarves.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/pkg-dwarves.git;a=summary
Homepage: http://oops.ghostprotocols.net:81/blog

Package: dwarves
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: set of advanced DWARF utilities
 This package contains tools that use the DWARF debugging information
 inserted in ELF binaries by the compiler. This information is already
 used by debuggers (e.g. GDB), and more recent tools such as systemtap.
 .
 Utilities in the dwarves suite include:
 .
  - pahole: finds alignment holes in structs and classes in languages
    such as C/C++, CPU cacheline alignment. Helps repack those structures
    to achieve more cache hits.
  - codiff: a diff like tool to compare the effects changes in source
    code generate on the resulting binaries
  - pfunct: displays all sorts of information about functions, inlines, etc.
  - pdwtags: pretty-prints DWARF information
  - pglobal: lists global symbols
  - prefcnt: counts DWARF tags usage
  - syscse: system call sign extender
  - dtagnames: lists tag names

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

export CFLAGS

configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir -p debian/build
	cd debian/build && cmake -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None" ../..
	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) VERBOSE=1 -C debian/build
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	[ ! -f debian/build/Makefile ] || $(MAKE) -C debian/build clean
	rm -rf debian/build config.h
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) -C debian/build install DESTDIR=$(CURDIR)/debian/tmp
	# remove them for now, will be included in a next upload
	# (requires python and matplotlib)
	rm -Rf debian/tmp/usr/share/dwarves/runtime/python debian/tmp/usr/bin/ostra-cg

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install --source=debian/tmp --fail-missing
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

get-orig-source:
	sh debian/get-orig.sh

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure get-orig-source

=== debian/watch ===
version=3

http://userweb.kernel.org/~acme/dwarves/dwarves-(.*)\.tar\.bz2

## dwarves-dfsg 1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 project(pahole C)
+cmake_minimum_required(VERSION 2.4.8)
+cmake_policy(SET CMP0005 NEW)
 
 INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )
 
@@ -25,33 +27,37 @@
 	     FORCE)
 endif (NOT CMAKE_BUILD_TYPE)
 
-add_definitions(-D_GNU_SOURCE)
+add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.9")
 find_package(DWARF REQUIRED)
+find_package(ZLIB REQUIRED)
 
 _set_fancy(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}${CMAKE_INSTALL_PREFIX}/${__LIB}" "libdir")
 
-set(dwarves_LIB_SRCS dwarves.c)
+set(dwarves_LIB_SRCS dwarves.c dwarves_fprintf.c gobuffer strings
+		     ctf_encoder.c ctf_loader.c libctf.c dwarf_loader.c
+		     dutil.c elf_symtab.c rbtree.c)
 add_library(dwarves SHARED ${dwarves_LIB_SRCS})
 set_target_properties(dwarves PROPERTIES VERSION 1.0.0 SOVERSION 1)
-target_link_libraries(dwarves ${DWARF_LIBRARIES})
+set_target_properties(dwarves PROPERTIES LINK_INTERFACE_LIBRARIES "")
+target_link_libraries(dwarves ${DWARF_LIBRARIES} ${ZLIB_LIBRARIES})
 
 set(dwarves_emit_LIB_SRCS dwarves_emit.c)
 add_library(dwarves_emit SHARED ${dwarves_emit_LIB_SRCS})
 set_target_properties(dwarves_emit PROPERTIES VERSION 1.0.0 SOVERSION 1)
-target_link_libraries(dwarves_emit ${DWARF_LIBRARIES} dwarves)
+target_link_libraries(dwarves_emit dwarves)
 
 set(dwarves_reorganize_LIB_SRCS dwarves_reorganize.c)
 add_library(dwarves_reorganize SHARED ${dwarves_reorganize_LIB_SRCS})
 set_target_properties(dwarves_reorganize PROPERTIES VERSION 1.0.0 SOVERSION 1)
-target_link_libraries(dwarves_reorganize ${DWARF_LIBRARIES} dwarves)
+target_link_libraries(dwarves_reorganize dwarves)
 
 set(codiff_SRCS codiff.c)
 add_executable(codiff ${codiff_SRCS})
 target_link_libraries(codiff dwarves)
 
-set(ctracer_SRCS ctracer.c dutil.c)
+set(ctracer_SRCS ctracer.c)
 add_executable(ctracer ${ctracer_SRCS})
-target_link_libraries(ctracer dwarves dwarves_emit dwarves_reorganize)
+target_link_libraries(ctracer dwarves dwarves_emit dwarves_reorganize ${ELF_LIBRARY})
 
 set(dtagnames_SRCS dtagnames.c)
 add_executable(dtagnames ${dtagnames_SRCS})
@@ -71,22 +77,29 @@
 
 set(pfunct_SRCS pfunct.c )
 add_executable(pfunct ${pfunct_SRCS})
-target_link_libraries(pfunct dwarves)
+target_link_libraries(pfunct dwarves dwarves_emit ${ELF_LIBRARY})
 
 set(prefcnt_SRCS prefcnt.c)
 add_executable(prefcnt ${prefcnt_SRCS})
 target_link_libraries(prefcnt dwarves)
+
+set(scncopy_SRCS scncopy.c elfcreator.c)
+add_executable(scncopy ${scncopy_SRCS})
+target_link_libraries(scncopy dwarves ${ELF_LIBRARY})
 
 set(syscse_SRCS syscse.c)
 add_executable(syscse ${syscse_SRCS})
 target_link_libraries(syscse dwarves)
 
 install(TARGETS codiff ctracer dtagnames pahole pdwtags
-		pfunct pglobal prefcnt syscse RUNTIME DESTINATION
+		pfunct pglobal prefcnt scncopy syscse RUNTIME DESTINATION
 		${CMAKE_INSTALL_PREFIX}/bin)
 install(TARGETS dwarves LIBRARY DESTINATION ${LIB_INSTALL_DIR})
 install(TARGETS dwarves dwarves_emit dwarves_reorganize LIBRARY DESTINATION ${LIB_INSTALL_DIR})
-install(FILES dwarves.h dwarves_emit.h dwarves_reorganize.h DESTINATION ${CMAKE_INSTALL_PREFIX}/include)
+install(FILES dwarves.h dwarves_emit.h dwarves_reorganize.h
+	      dutil.h gobuffer.h list.h rbtree.h strings.h
+	DESTINATION ${CMAKE_INSTALL_PREFIX}/include/dwarves/)
+install(FILES man-pages/pahole.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1/)
 install(PROGRAMS ostra/ostra-cg DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
 install(FILES ostra/python/ostra.py DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime/python)
 install(FILES lib/Makefile lib/ctracer_relay.c lib/ctracer_relay.h lib/linux.blacklist.cu

=== debian/changelog ===
dwarves-dfsg (1.10-2.1build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:20:24 +0000

dwarves-dfsg (1.10-2.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Robie Basak ]
  * Fix FTBFS with newer elfutils. (Closes: #764484)

 -- James Cowgill <jcowgill@debian.org>  Thu, 24 Mar 2016 13:01:08 +0000

dwarves-dfsg (1.10-2) unstable; urgency=low

  * Make sure CMake uses standard library location if host has no
    MultiArch. Closes: #665054.

 -- Thomas Girard <thomas.g.girard@free.fr>  Sat, 16 Jun 2012 10:50:15 +0200

dwarves-dfsg (1.10-1) unstable; urgency=low

  * New upstram release.
  * Record patches using dpkg-source --commit. Closes: #643102.
  * Use MultiArch elfutils location. Closes: #665054.
  * debian/control: change homepage to new location.
  * debian/watch: change source tarball location.
  * debian/control: bump Standards-Version: to 3.9.3. No changes needed.
  * debian/rules: add missing build-arch and build-indep targets.

 -- Thomas Girard <thomas.g.girard@free.fr>  Fri, 08 Jun 2012 20:55:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: dwarves-dfsg
 Priority: extra
-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
 Build-Depends: debhelper (>= 7), libelf-dev, libdw-dev (>= 0.141), cmake (>= 2.4.8), zlib1g-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Section: utils
 Vcs-Git: git://git.debian.org/collab-maint/pkg-dwarves.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/pkg-dwarves.git;a=summary
-Homepage: http://oops.ghostprotocols.net:81/blog
+Homepage:  http://acmel.wordpress.com
 
 Package: dwarves
 Architecture: any

=== debian/watch ===
version=3

http://fedorapeople.org/~acme/dwarves/dwarves-(.*)\.tar\.bz2

## dwarves-dfsg 1.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,18 +27,18 @@
 	     FORCE)
 endif (NOT CMAKE_BUILD_TYPE)
 
-add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.9")
+add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.12")
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 
 _set_fancy(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}${CMAKE_INSTALL_PREFIX}/${__LIB}" "libdir")
 
 set(dwarves_LIB_SRCS dwarves.c dwarves_fprintf.c gobuffer strings
-		     ctf_encoder.c ctf_loader.c libctf.c dwarf_loader.c
-		     dutil.c elf_symtab.c rbtree.c)
+		     ctf_encoder.c ctf_loader.c libctf.c btf_encoder.c libbtf.c
+		     dwarf_loader.c dutil.c elf_symtab.c rbtree.c)
 add_library(dwarves SHARED ${dwarves_LIB_SRCS})
 set_target_properties(dwarves PROPERTIES VERSION 1.0.0 SOVERSION 1)
-set_target_properties(dwarves PROPERTIES LINK_INTERFACE_LIBRARIES "")
+set_target_properties(dwarves PROPERTIES INTERFACE_LINK_LIBRARIES "")
 target_link_libraries(dwarves ${DWARF_LIBRARIES} ${ZLIB_LIBRARIES})
 
 set(dwarves_emit_LIB_SRCS dwarves_emit.c)

=== debian/changelog ===
dwarves-dfsg (1.12-1) unstable; urgency=medium

  [ Domenico Andreoli ]
  * New upstram release. Closes: #908563, #779809, #693096,
  * Migrate to salsa.d.o and enable CI. Closes: #908564.
  * Migrate to DEP-14.
  * Drop patch DW_TAG_mutable_type (merged upstream).
  * Refresh patch no_shared_no_ebl.
  * Improve package description. Closes: #914527.
  * Add test executing pahole on itself.
  * Set debhelper compatibility level to 10.
  * Start using dh_strip_nondeterminism.

  [ Helmut Grohne ]
  * Let dh_auto_configure pass cross flags to cmake. Closes: #903506.

 -- Domenico Andreoli <cavok@debian.org>  Mon, 19 Nov 2018 18:11:43 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: dwarves-dfsg
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
+Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
 Build-Depends: debhelper (>= 7), libelf-dev, libdw-dev (>= 0.141), cmake (>= 2.4.8), zlib1g-dev
 Standards-Version: 3.9.3
 Section: utils
-Vcs-Git: git://git.debian.org/collab-maint/pkg-dwarves.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/pkg-dwarves.git;a=summary
+Vcs-Browser: https://salsa.debian.org/debian/dwarves
+Vcs-Git: git@salsa.debian.org:debian/dwarves.git
 Homepage:  http://acmel.wordpress.com
 
 Package: dwarves
@@ -15,8 +14,8 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: set of advanced DWARF utilities
  This package contains tools that use the DWARF debugging information
- inserted in ELF binaries by the compiler. This information is already
- used by debuggers (e.g. GDB), and more recent tools such as systemtap.
+ inserted in ELF binaries by the compiler. This information is used by
+ debuggers (e.g. GDB), and other tools such as systemtap.
  .
  Utilities in the dwarves suite include:
  .

=== debian/rules ===
--- 
+++ 
@@ -15,11 +15,12 @@
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-	mkdir -p debian/build
-	cd debian/build && cmake -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None" ../..
+	dh_auto_configure --builddirectory=debian/build -- -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None"
 	touch $@
 
-build: build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 build-stamp: configure-stamp
 	dh_testdir
 	$(MAKE) VERBOSE=1 -C debian/build
@@ -60,6 +61,7 @@
 	dh_link
 	dh_strip
 	dh_compress
+	dh_strip_nondeterminism
 	dh_fixperms
 	dh_installdeb
 	dh_shlibdeps

=== debian/tests/control ===
Test-Command: pahole `which pahole`
Depends: dwarves-dbgsym

## dwarves-dfsg 1.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(pahole C)
-cmake_minimum_required(VERSION 2.4.8)
+cmake_minimum_required(VERSION 2.8.8)
 cmake_policy(SET CMP0005 NEW)
 
 INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )
@@ -27,16 +27,61 @@
 	     FORCE)
 endif (NOT CMAKE_BUILD_TYPE)
 
-add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.12")
+add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.15")
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 
+# make sure git submodule(s) are checked out
+find_package(Git QUIET)
+if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
+	# Update submodules as needed
+	option(GIT_SUBMODULE "Check submodules during build" ON)
+	if(GIT_SUBMODULE)
+		message(STATUS "Submodule update")
+		execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
+				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+				RESULT_VARIABLE GIT_SUBMOD_RESULT)
+		if(NOT GIT_SUBMOD_RESULT EQUAL "0")
+			message(FATAL_ERROR "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
+		else()
+			message(STATUS "Submodule update - done")
+		endif()
+	endif()
+endif()
+if(NOT EXISTS "${PROJECT_SOURCE_DIR}/lib/bpf/src/btf.h")
+	message(FATAL_ERROR "The submodules were not downloaded! GIT_SUBMODULE was turned off or failed. Please update submodules and try again.")
+endif()
+
 _set_fancy(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}${CMAKE_INSTALL_PREFIX}/${__LIB}" "libdir")
 
+# libbpf uses reallocarray, which is not available in all versions of glibc
+# libbpf's include/tools/libc_compat.h provides implementation, but needs
+# COMPACT_NEED_REALLOCARRAY to be set
+INCLUDE(CheckCSourceCompiles)
+CHECK_C_SOURCE_COMPILES(
+"
+#define _GNU_SOURCE
+#include <stdlib.h>
+int main(void)
+{
+        return !!reallocarray(NULL, 1, 1);
+}
+" HAVE_REALLOCARRAY_SUPPORT)
+if (NOT HAVE_REALLOCARRAY_SUPPORT)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCOMPAT_NEED_REALLOCARRAY")
+endif()
+
+file(GLOB libbpf_sources "lib/bpf/src/*.c")
+add_library(bpf OBJECT ${libbpf_sources})
+set_property(TARGET bpf PROPERTY POSITION_INDEPENDENT_CODE 1)
+target_include_directories(bpf PRIVATE
+			   ${CMAKE_CURRENT_SOURCE_DIR}/lib/bpf/include
+			   ${CMAKE_CURRENT_SOURCE_DIR}/lib/bpf/include/uapi)
+
 set(dwarves_LIB_SRCS dwarves.c dwarves_fprintf.c gobuffer strings
-		     ctf_encoder.c ctf_loader.c libctf.c btf_encoder.c libbtf.c
+		     ctf_encoder.c ctf_loader.c libctf.c btf_encoder.c btf_loader.c libbtf.c
 		     dwarf_loader.c dutil.c elf_symtab.c rbtree.c)
-add_library(dwarves SHARED ${dwarves_LIB_SRCS})
+add_library(dwarves SHARED ${dwarves_LIB_SRCS} $<TARGET_OBJECTS:bpf>)
 set_target_properties(dwarves PROPERTIES VERSION 1.0.0 SOVERSION 1)
 set_target_properties(dwarves PROPERTIES INTERFACE_LINK_LIBRARIES "")
 target_link_libraries(dwarves ${DWARF_LIBRARIES} ${ZLIB_LIBRARIES})
@@ -75,7 +120,7 @@
 add_executable(pglobal ${pglobal_SRCS})
 target_link_libraries(pglobal dwarves)
 
-set(pfunct_SRCS pfunct.c )
+set(pfunct_SRCS pfunct.c)
 add_executable(pfunct ${pfunct_SRCS})
 target_link_libraries(pfunct dwarves dwarves_emit ${ELF_LIBRARY})
 
@@ -98,9 +143,12 @@
 install(TARGETS dwarves dwarves_emit dwarves_reorganize LIBRARY DESTINATION ${LIB_INSTALL_DIR})
 install(FILES dwarves.h dwarves_emit.h dwarves_reorganize.h
 	      dutil.h gobuffer.h list.h rbtree.h strings.h
+	      btf_encoder.h config.h ctf_encoder.h ctf.h
+	      elfcreator.h elf_symtab.h hash.h libbtf.h libctf.h
 	DESTINATION ${CMAKE_INSTALL_PREFIX}/include/dwarves/)
 install(FILES man-pages/pahole.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1/)
 install(PROGRAMS ostra/ostra-cg DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
+install(PROGRAMS btfdiff fullcircle DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
 install(FILES ostra/python/ostra.py DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime/python)
 install(FILES lib/Makefile lib/ctracer_relay.c lib/ctracer_relay.h lib/linux.blacklist.cu
 	DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dwarves/runtime)

=== lib/bpf/src/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)

TOPDIR = ..

INCLUDES := -I. -I$(TOPDIR)/include -I$(TOPDIR)/include/uapi
ALL_CFLAGS := $(INCLUDES)

FEATURE_REALLOCARRAY := $(shell $(TOPDIR)/scripts/check-reallocarray.sh)
ifneq ($(FEATURE_REALLOCARRAY),)
	ALL_CFLAGS += -DCOMPAT_NEED_REALLOCARRAY
endif

ifdef BUILD_SHARED
	ALL_CFLAGS += -fPIC -fvisibility=hidden
endif

CFLAGS ?= -g -O2 -Werror -Wall
ALL_CFLAGS += $(CFLAGS)

OBJDIR ?= .

OBJS := $(addprefix $(OBJDIR)/,bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o xsk.o)

LIBS := $(OBJDIR)/libbpf.a
ifdef BUILD_SHARED
	LIBS += $(OBJDIR)/libbpf.so
endif

HEADERS := bpf.h libbpf.h btf.h
UAPI_HEADERS := $(addprefix $(TOPDIR)/include/uapi/linux/,bpf.h bpf_common.h \
	btf.h)

INSTALL = install

DESTDIR ?=

ifeq ($(shell uname -m),x86_64)
	LIBSUBDIR := lib64
else
	LIBSUBDIR := lib
endif

PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/$(LIBSUBDIR)
INCLUDEDIR ?= $(PREFIX)/include
UAPIDIR ?= $(PREFIX)/include

all: $(LIBS)

$(OBJDIR)/libbpf.a: $(OBJS)
	$(AR) rcs $@ $^

$(OBJDIR)/libbpf.so: $(OBJS)
	$(CC) -shared $(LDFLAGS) $^ -o $@

$(OBJDIR)/%.o: %.c
	$(CC) $(ALL_CFLAGS) -c $< -o $@

define do_install
	if [ ! -d '$(DESTDIR)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
	fi;						\
	$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR)$2'
endef

install: all install_headers
	$(call do_install,$(LIBS),$(LIBDIR))

install_headers:
	$(call do_install,$(HEADERS),$(INCLUDEDIR)/bpf,644)

# UAPI headers can be installed by a different package so they're not installed
# in by install rule.
install_uapi_headers:
	$(call do_install,$(UAPI_HEADERS),$(UAPIDIR)/linux,644)

clean:
	rm -f *.o *.a *.so

=== debian/changelog ===
dwarves-dfsg (1.15-2) unstable; urgency=low

  * Fix hardening-no-bindnow.
  * Fix debian-watch-uses-insecure-uri.
  * Fix debian-watch-does-not-check-gpg-signature.
  * Fix priority-extra-is-replaced-by-priority-optional.
  * Revert to dwarves-dbgsym for tests execution but skip the test if
    it's not installable (i.e. on transition to testing).

 -- Domenico Andreoli <cavok@debian.org>  Mon, 23 Sep 2019 18:21:35 +0200

dwarves-dfsg (1.15-1) unstable; urgency=medium

  [ Theodore Y. Ts'o ]
  * New upstream release (changes since 1.12, closes: #931142):
    - Add support for BTF encoding which is a much more compact way
      of encoding C type information.  It is derived from CTF (Compact
      C-Type format) and is designed for use with eBPF.
    - Add initial support for the DWARF DW_TAG_partial_unit
    - Improve support for pretty-printing unions
    - Teach pahole to show where a struct was used, via the -I option
    - Use the running kernel by default when no file name is passed
    - Improve man pages
    - Support new BTF deduplication algorithm found the Linux kernel's
      libbpf library, which allows type information for the kernel to
      be stored in roughly 1% of the space.
    - Add a new utility, btfdiff, which compares the pretty-printed
      type information between two kernel images.
    - Teach pahole to use the BTF information to pretty print structures
      using the BTF information using "pahole -F btf", which is much faster
      than using the Dwarf information.
    - Infer the __packed__ attribute for structures without alignment holes
      and which violate the natural types' alignment requirements.
    - Support DWARF5's DW_AT_alignment tag
    - Add a --compile option to pfunct which produces compileable
      output for function prototypes in an object file.
    - Miscellaneous bug fixes

  [ Domenico Andreoli ]
  * Autopkgtest on libc-bin-dbgsym instead of dwarves-dbgsym. Closes: #923717.
  * Fix typo in description of no_shared_no_ebl.

 -- Domenico Andreoli <cavok@debian.org>  Tue, 30 Jul 2019 16:58:55 +0200

dwarves-dfsg (1.12-2) unstable; urgency=medium

  * Convert to dh.
  * Fix Homepage and Vcs-Git.
  * Fix depends on debhelper >= 10.
  * Remove trailing spaces from the Debian changelog.
  * Update copyright to copyright-format/1.0. Closes: #919356.

 -- Domenico Andreoli <cavok@debian.org>  Wed, 27 Feb 2019 18:09:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: dwarves-dfsg
-Priority: extra
+Priority: optional
 Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper (>= 7), libelf-dev, libdw-dev (>= 0.141), cmake (>= 2.4.8), zlib1g-dev
+Build-Depends: debhelper (>= 10), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141)
 Standards-Version: 3.9.3
 Section: utils
 Vcs-Browser: https://salsa.debian.org/debian/dwarves
-Vcs-Git: git@salsa.debian.org:debian/dwarves.git
-Homepage:  http://acmel.wordpress.com
+Vcs-Git: https://salsa.debian.org/debian/dwarves.git
+Homepage: http://acmel.wordpress.com
 
 Package: dwarves
 Architecture: any

=== debian/rules ===
#! /usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --builddirectory=debian/build

override_dh_auto_configure:
	dh_auto_configure -- -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None"

override_dh_auto_install-arch:
	$(MAKE) -C debian/build install DESTDIR=$(CURDIR)/debian/tmp
	# remove them for now, will be included in a next upload
	# (requires python and matplotlib)
	rm -Rf debian/tmp/usr/share/dwarves/runtime/python debian/tmp/usr/bin/ostra-cg

get-orig-source:
	sh debian/get-orig.sh

.PHONY: get-orig-source

=== debian/tests/control ===
Test-Command: pahole /usr/bin/pahole
Depends: dwarves-dbgsym
Restrictions: skip-not-installable

## dwarves-dfsg 1.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,10 @@
 	     FORCE)
 endif (NOT CMAKE_BUILD_TYPE)
 
-add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.15")
+set(CMAKE_C_FLAGS_DEBUG "-Wall -Werror -ggdb -O2")
+set(CMAKE_C_FLAGS_RELEASE "-Wall -O2")
+
+add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.17")
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 
@@ -71,6 +74,8 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DCOMPAT_NEED_REALLOCARRAY")
 endif()
 
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64")
+
 file(GLOB libbpf_sources "lib/bpf/src/*.c")
 add_library(bpf OBJECT ${libbpf_sources})
 set_property(TARGET bpf PROPERTY POSITION_INDEPENDENT_CODE 1)
@@ -84,6 +89,8 @@
 add_library(dwarves SHARED ${dwarves_LIB_SRCS} $<TARGET_OBJECTS:bpf>)
 set_target_properties(dwarves PROPERTIES VERSION 1.0.0 SOVERSION 1)
 set_target_properties(dwarves PROPERTIES INTERFACE_LINK_LIBRARIES "")
+target_include_directories(dwarves PRIVATE
+			   ${CMAKE_CURRENT_SOURCE_DIR}/lib/bpf/include/uapi)
 target_link_libraries(dwarves ${DWARF_LIBRARIES} ${ZLIB_LIBRARIES})
 
 set(dwarves_emit_LIB_SRCS dwarves_emit.c)

=== debian/changelog ===
dwarves-dfsg (1.17-1) unstable; urgency=low

  * New upstream release (changes since 1.16):

    BTF loader:
     - Support raw BTF as available in /sys/kernel/btf/vmlinux.

    pahole:
     - When the sole argument passed isn't a file, take it as a class name:
     - Do not require a class name to operate without a file name.
     - Make --find_pointers_to consider unions:
     - Make --contains and --find_pointers_to honour --unions
     - Add support for finding pointers to void:
     - Make --contains and --find_pointers_to to work with base types:
     - Make --contains look for more than just unions, structs:
     - Consider unions when looking for classes containing some class:
     - Introduce --unions to consider just unions:
     - Fix -m/--nr_methods - Number of functions operating on a type pointer

    man-pages:
     - Add section about --hex + -E to locate offsets deep into sub structs.
     - Add more information about BTF.
     - Add some examples.

  * Update to Standards-Version 4.5.0:
    - Drop get-orig-source rules target
    - Add Rules-Requires-Root: no
  * Update debhelper compat to 12.

 -- Domenico Andreoli <cavok@debian.org>  Sun, 19 Apr 2020 20:25:33 +0200

dwarves-dfsg (1.16-1) unstable; urgency=low

  * New upstream release (changes since 1.15):
    - Preserve and encode exported functions as BTF_KIND_FUNC
    - Add support for BTF_KIND_FUNC
    - Account inline type __aligned__ member types for spacing
    - Fix alignment of class members that are structs/enums/unions
    - Fixup handling classes with no members, solving a NULL deref
    - Avoid infinite loop trying to determine type with static data
      member of its own type.
    - type->type == 0 is void, fix --compile for that
    - Print DW_TAG_subroutine_type as well
    - Fix ptr_table__add_with_id() handling of pt->nr_entries, covering
      how BTF variables IDs are encoded
    - Allow passing the format path specifier, to use with BTF
    - Fixup issues pointed out by various coverity reports

 -- Domenico Andreoli <cavok@debian.org>  Wed, 15 Jan 2020 18:02:11 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Priority: optional
 Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper (>= 10), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141)
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 12), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141)
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Section: utils
 Vcs-Browser: https://salsa.debian.org/debian/dwarves
 Vcs-Git: https://salsa.debian.org/debian/dwarves.git

=== debian/rules ===
--- 
+++ 
@@ -16,8 +16,3 @@
 	# remove them for now, will be included in a next upload
 	# (requires python and matplotlib)
 	rm -Rf debian/tmp/usr/share/dwarves/runtime/python debian/tmp/usr/bin/ostra-cg
-
-get-orig-source:
-	sh debian/get-orig.sh
-
-.PHONY: get-orig-source

## dwarves-dfsg 1.18

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,10 +27,10 @@
 	     FORCE)
 endif (NOT CMAKE_BUILD_TYPE)
 
-set(CMAKE_C_FLAGS_DEBUG "-Wall -Werror -ggdb -O2")
+set(CMAKE_C_FLAGS_DEBUG "-Wall -Werror -ggdb -O0")
 set(CMAKE_C_FLAGS_RELEASE "-Wall -O2")
 
-add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.17")
+add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.18")
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)

=== debian/changelog ===
dwarves-dfsg (1.18-1) unstable; urgency=medium

  [ Domenico Andreoli ]
  * New upstream release (changes since 1.17):
    - Use type information to pretty print raw data from stdin, all
      documented in the man pages, further information in the csets.
    - Store percpu variables in vmlinux BTF. This can be disabled when
      debugging kernel features being developed to use it.
    - pahole now should be segfault free when handling gdb test suit
      DWARF files, including ADA, FORTRAN, rust and dwp compressed files,
      the later being just flatly refused, that got left for v1.19.
    - Bail out on partial units for now, avoiding segfaults and providing
      warning to user, hopefully will be addressed in v1.19.
      Closes: #977715.
  * Update Homepage link. Closes: #978708.
  * Drop debian/compat in favor of Build-Depends: debhelper-compat.
  * Fix typo in pahole manual page.
  * Fix escaping in pahole manual page.
  * Fix debian/copyright lintian errors.
  * Revert test to a superficial pahole --version until partial units
    become supported.

  [ Luca Boccassi ]
  * Use packaged libbpf instead of the statically linked. Closes: #979105.

 -- Domenico Andreoli <cavok@debian.org>  Sun, 03 Jan 2021 13:41:31 +0100

## dwarves-dfsg 1.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,9 @@
 cmake_minimum_required(VERSION 2.8.8)
 cmake_policy(SET CMP0005 NEW)
 
-INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )
+INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}
+		    ${CMAKE_CURRENT_SOURCE_DIR}
+		    ${CMAKE_CURRENT_SOURCE_DIR}/lib/bpf/include/uapi)
 
 # Try to parse this later, Helio just showed me a KDE4 example to support
 # x86-64 builds.
@@ -30,7 +32,10 @@
 set(CMAKE_C_FLAGS_DEBUG "-Wall -Werror -ggdb -O0")
 set(CMAKE_C_FLAGS_RELEASE "-Wall -O2")
 
-add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.18")
+# Just for grepping, DWARVES_VERSION isn't used anywhere anymore
+# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.19")
+add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
+add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=19)
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)
 
@@ -149,7 +154,7 @@
 install(TARGETS dwarves LIBRARY DESTINATION ${LIB_INSTALL_DIR})
 install(TARGETS dwarves dwarves_emit dwarves_reorganize LIBRARY DESTINATION ${LIB_INSTALL_DIR})
 install(FILES dwarves.h dwarves_emit.h dwarves_reorganize.h
-	      dutil.h gobuffer.h list.h rbtree.h strings.h
+	      dutil.h gobuffer.h list.h rbtree.h pahole_strings.h
 	      btf_encoder.h config.h ctf_encoder.h ctf.h
 	      elfcreator.h elf_symtab.h hash.h libbtf.h libctf.h
 	DESTINATION ${CMAKE_INSTALL_PREFIX}/include/dwarves/)

=== debian/changelog ===
dwarves-dfsg (1.19-1~bpo10+1) buster-backports; urgency=medium

  * Non-maintainer upload.
  * Rebuild for buster-backports.

 -- Luca Boccassi <bluca@debian.org>  Wed, 10 Feb 2021 09:27:14 +0000

dwarves-dfsg (1.19-1) unstable; urgency=high

  * New upstream release. Closes: #978691.
    Changes since 1.18:
    - Support split BTF, where a main BTF file, vmlinux, can be used
      to find types and then a kernel module, for instance, can have
      just what is unique to it
    - Update libbpf to get the split BTF support and use some of its
      functions to load BTF and speed up DWARF loading and BTF encoding
    - Support cross-compiled ELF binaries with different endianness
    - Support showing typedefs for anonymous types, like structs,
      unions and enums
    - Align enumerators
    - Workaround bugs in the generation of DWARF records for functions in
      some gcc versions that were causing breakage in the encoding of BTF
    - Ignore zero-sized ELF symbols instead of erroring out
    - Handle union forward declaration properly in the BTF loader
    - Introduce --numeric_version for use in scripts and Makefiles
    - Try sole pfunct argument as a function name, just like pahole
      with type names
    - Speed up pfunct using some of the load techniques used in pahole
    - Discard CUs after BTF encoding as they're not used anymore,
      greatly reducing memory usage and speeding up vmlinux BTF encoding
    - Revamp how per-CPU variables are encoded in BTF
    - Include BTF info for static functions
    - Use BTF's string APIs for strings management, greatly improving
      performance over the tsearch()
    - Increase size of DWARF lookup hash table, shaving off about 1
      second out of about 20 seconds total for Linux BTF dedup
    - Stop BTF encoding when errors are found in some DWARF CU
    - Implement --packed, to show just packed structures, for instance,
      here are the top 5 packed data structures in the Linux kernel
    - Fix bug in distros such as OpenSUSE:15.2 where DW_AT_alignment
      isn't defined

  * Refresh patches.

 -- Domenico Andreoli <cavok@debian.org>  Mon, 04 Jan 2021 23:33:54 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Priority: optional
 Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper (>= 12), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141)
+Build-Depends: debhelper-compat (= 12), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.2~), pkg-config,
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Section: utils
 Vcs-Browser: https://salsa.debian.org/debian/dwarves
 Vcs-Git: https://salsa.debian.org/debian/dwarves.git
-Homepage: http://acmel.wordpress.com
+Homepage: https://git.kernel.org/pub/scm/devel/pahole/pahole.git
 
 Package: dwarves
 Architecture: any

## dwarves-dfsg 1.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(pahole C)
-cmake_minimum_required(VERSION 2.8.8)
+cmake_minimum_required(VERSION 2.8.12)
 cmake_policy(SET CMP0005 NEW)
 
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}
@@ -33,9 +33,9 @@
 set(CMAKE_C_FLAGS_RELEASE "-Wall -O2")
 
 # Just for grepping, DWARVES_VERSION isn't used anywhere anymore
-# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.19")
+# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.20")
 add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
-add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=19)
+add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=20)
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)

=== debian/changelog ===
dwarves-dfsg (1.20-1) unstable; urgency=medium

  * New upstream release.
    Changes since 1.19:

    BTF encoder:
      - Improve ELF error reporting using elf_errmsg(elf_errno()).
      - Improve objcopy error handling.
      - Fix handling of 'restrict' qualifier, that was being treated
        as a 'const'.
      - Support SHN_XINDEX in st_shndx symbol indexes, to handle ELF
        objects with more than 65534 sections, for instance, which
        happens with kernels built with 'KCFLAGS="-ffunction-sections
        -fdata-sections", Other cases may include when using FG-ASLR, LTO.
      - Cope with functions without a name, as seen sometimes when
        building kernel images with some versions of clang, when a
        SEGFAULT was taking place.
      - Fix BTF variable generation for kernel modules, not skipping
        variables at offset zero.
      - Fix address size to match what is in the ELF file being
        processed, to fix using a 64-bit pahole binary to generate BTF
        for a 32-bit vmlinux image.
      - Use kernel module ftrace addresses when finding which functions
        to encode, which increases the number of functions encoded.
    DWARF loader:
      - Support DW_AT_data_bit_offset
      - DW_FORM_implicit_const in attr_numeric() and attr_offset()
      - Support DW_TAG_GNU_call_site, its the standardized rename of
        the previously supported DW_TAG_GNU_call_site.
    build:
        - Fix compilation on 32-bit architectures.

  * Refresh patches.
  * Remove ctfdwdiff and README.cross so to reuse upstream tarball as-is.
  * Update Standards-Version to 4.5.1
  * Update debhelper compatibility to 13:
    - install missing binaries: btfdiff and fullcircle
  * Add upstream metadata file
  * gbp: set upstream tarball compression to xz
  * Add lintian override for orig-tarball-missing-upstream-signature,
    see #882694.

 -- Domenico Andreoli <cavok@debian.org>  Sun, 07 Feb 2021 17:59:01 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Priority: optional
 Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper-compat (= 12), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.2~), pkg-config,
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.2~), pkg-config,
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Section: utils
 Vcs-Browser: https://salsa.debian.org/debian/dwarves

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	dh $@ --builddirectory=debian/build
 
 override_dh_auto_configure:
-	dh_auto_configure -- -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None"
+	dh_auto_configure -- -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None" -DLIBBPF_EMBEDDED=off
 
 override_dh_auto_install-arch:
 	$(MAKE) -C debian/build install DESTDIR=$(CURDIR)/debian/tmp

## dwarves-dfsg 1.21

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,9 +33,9 @@
 set(CMAKE_C_FLAGS_RELEASE "-Wall -O2")
 
 # Just for grepping, DWARVES_VERSION isn't used anywhere anymore
-# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.20")
+# add_definitions(-D_GNU_SOURCE -DDWARVES_VERSION="v1.21")
 add_definitions(-D_GNU_SOURCE -DDWARVES_MAJOR_VERSION=1)
-add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=20)
+add_definitions(-D_GNU_SOURCE -DDWARVES_MINOR_VERSION=21)
 find_package(DWARF REQUIRED)
 find_package(ZLIB REQUIRED)

=== debian/changelog ===
dwarves-dfsg (1.21-0ubuntu1~20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free vulnerability
    - debian/patches/CVE-2022-3534.patch: Fix use-after-free in
      btf_dump_name_dups
    - CVE-2022-3534
  * SECURITY UPDATE: null pointer dereference vulnerability
    - debian/patches/CVE-2022-3606.patch: Fix null-pointer dereference in
      find_prog_by_sec_insn()
    - CVE-2022-3606

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Wed, 05 Jul 2023 10:25:24 +0100

dwarves-dfsg (1.21-0ubuntu1~20.04) focal; urgency=medium

  * Backport new dwarves-dfsg to stable series without upgrading libbpf
    system-wide (LP: #1912811):
    + Update lib/bpf to libbpf_0.4.0-1ubuntu1.
    + Disable lto, since it is disabled in libbpf.
    + Build with embedded libbpf.
    + Drop libbpf-dev build dependency.
    + Lower debhelper-compat to 12.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Mon, 20 Sep 2021 13:10:02 +0100

dwarves-dfsg (1.21-0ubuntu1) impish; urgency=medium

  * New upstream release. Remaining changes:
    - pahole: cherry-pick removal of the ftrace filter and its related
    functions to prevent build errors with linux 5.13.
    - build with libbpf 0.4, as will be required in the next release.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 16 Jun 2021 09:57:20 +0100

dwarves-dfsg (1.20-1ubuntu1) impish; urgency=medium

  * pahole: remove the ftrace filter and its related functions to prevent
    build errors with linux 5.13 (LP: #1928244)

 -- Andrea Righi <andrea.righi@canonical.com>  Wed, 12 May 2021 18:00:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: dwarves-dfsg
 Priority: optional
-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thomas Girard <thomas.g.girard@free.fr>
 Uploaders: Domenico Andreoli <cavok@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), libbpf-dev (>= 1:0.2~), pkg-config,
+Build-Depends: debhelper-compat (= 12), cmake (>= 2.4.8), zlib1g-dev, libelf-dev, libdw-dev (>= 0.141), pkg-config,
 Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Section: utils

=== debian/rules ===
#! /usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --builddirectory=debian/build

override_dh_auto_configure:
	dh_auto_configure -- -D__LIB=lib -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE="None" -DLIBBPF_EMBEDDED=on

override_dh_auto_install-arch:
	$(MAKE) -C debian/build install DESTDIR=$(CURDIR)/debian/tmp
	# remove them for now, will be included in a next upload
	# (requires python and matplotlib)
	rm -Rf debian/tmp/usr/share/dwarves/runtime/python debian/tmp/usr/bin/ostra-cg
